class Amber::Storage::Json < Amber::Storage
  include Amber::StorageDelegate
  
  def initialize(model, file_name)
    super model, Amber::Storage::Driver::File.new(file_name)
    if @driver.mount
      @status = true
    end
    @data = {}
  end
  
  def get(id)
    self.refresh
    @data[id.to_s]
  end

  def post(model)
    self.refresh
    @data[model.id]
  end

  def patch(id, model)
    
  end

  def delete(id)
    
  end

  def refresh
    data = @driver.read
    data = self.parse data
    if data
      @data = data
    end
  end

  def parse(data)
    begin
      JSON.parse data
    rescue Exception => e
      p e
    end
  end

  def generate(data)
    begin
      JSON.generate data
    rescue Exception => e
      p e
    end
  end
end